/* zmdplay.c */
#include <stdio.h>
#include <stdlib.h>
#include <sys/iocs.h>

#include "zmcall.h"



void usage (void)
{
	printf (
		       ".ZMD t@CteXg zmdplay.x ver0.01\n"
		       "		programmed by Mitsuky <FreeSoftware>\n"
		       "PT034MK.ZMD ǂݍŉtAAXE0004.PCM Đ܂\n"
		);
}



int main (int argc, char *argv[])
{
	FILE *fp;
	void *zmd_file, *pcm_file;
	int zmd_size, pcm_size;

	if (argc > 1) {
		usage ();
		return (-1);
	}
	/* PT034MK.ZMD ɓǂݍ */
	fp = fopen ("PT034MK.ZMD", "rb");
	if (fp == NULL) {
		printf ("PT034MK.ZMD ǂݍ߂܂\n");
		return (-1);
	}
	fseek (fp, 0, SEEK_END);
	zmd_size = ftell (fp);
	fseek (fp, 0, SEEK_SET);
	zmd_file = malloc (zmd_size);
	if (zmd_file == NULL) {
		printf ("܂\n");
		return (-1);
	}
	fread (zmd_file, sizeof (char), zmd_size, fp);
	fclose (fp);

	/* AXE0004.PCM ɓǂݍ */
	fp = fopen ("AXE0004.PCM", "rb");
	if (fp == NULL) {
		printf ("AXE0004.PCM ǂݍ߂܂\n");
		return (-1);
	}
	fseek (fp, 0, SEEK_END);
	pcm_size = ftell (fp);
	fseek (fp, 0, SEEK_SET);
	pcm_file = malloc (pcm_size);
	if (pcm_file == NULL) {
		printf ("܂\n");
		return (-1);
	}
	fread (pcm_file, sizeof (char), pcm_size, fp);
	fclose (fp);


	if (ZmKeepCheck () < 0) {
		printf ("ZMUSIC 풓Ă܂\n");
		return (-1);
	}
	ZmInit ();		/* ZMUSIC  */
	ZmPlay (zmd_file, zmd_size);	/* .ZMD t */

	printf ("WCXeBbN [A] {^ƌʉĐ܂\n"
		"[B] {^ŏI܂\n");

	for (;;) {
		int j;		/* WCXeBbN̓ */

		j = _iocs_joyget (0);	/* WCXeBbNO */

		/* [A] {^ꂽH */
		if ((j & 0b00100000) == 0) {
			ZmAdpcmSE (pcm_file, pcm_size, 4 * 256 + 3, 0);		/* ʉĐ */
			/* [A] {^̂҂ */
			while ((_iocs_joyget (0) & 0b00100000) == 0);
		}
		/*
		   ZmAdpcmSE() ̈
		   ADPCM f[^ւ̃|C^,
		   ADPCM f[^̃TCY,
		   g*256+PAN,
		   D揇
		 */

		/* [B] {^ꂽH */
		if ((j & 0b1000000) == 0)
			break;
	}

	ZmStop ();		/* y~ */

	free (zmd_file);
	free (pcm_file);

	return (0);
}
